define(["has"], function(has){
	has.add("dom-create-style-element", !document.createStyleSheet);
	function processCss(css, baseUrl){
		css = css.replace(/(@media\s+|@import\s+[^\s]+\s+)(.+);/g, function(t, rule, query){
			var parts = query.split(" and ");
			for(var part, i = 0; part = parts[i]; i++){
				var undefined, featureValue = part.match(/\((not )?([\w-]+)(:\s*([^\)]+))?\)/);
				if(featureValue){
					var not = featureValue[1];
					var feature = featureValue[2];
					var prefix = feature.substring(0, feature.indexOf("-"));
					var result = (prefix == "min" || prefix == "max") ? has("css-" + feature.substring(4)) :
									prefix == "agent" ? new RegExp(feature.substring(6), "i").test(navigator.userAgent) : 
									has(prefix == "has" ? feature.substring(4) : ("css-" + feature));
					if(result !== undefined){
						if(prefix == "min"){
							result = result <= featureValue[4];
						}
						if(prefix == "max"){
							result = result >= featureValue[4];
						}
						if(!result != !not){
							parts.splice(i--, 1);
						}else{
							return ""; // didn't match, remove entire media query
						}
					}
				}
			}
			return rule + parts.join(" and ") + ';';
		});
		return css.replace(/url\("?([^\)"]+)"?\)/g, function(t, url){
			if(url.charAt(0) != "/"){
				url = baseUrl + url; 
			}
			return "url(" + url + ")";
		}); 
	}
	function insertLink(href){
		if(has("dom-create-style-element")){
			// we can use standard <link> element creation
			styleSheet = document.createElement("link");
			styleSheet.setAttribute("type", "text/css");
			styleSheet.setAttribute("rel", "stylesheet");
			styleSheet.setAttribute("href", href);
			document.getElementsByTagName("head")[0].appendChild(styleSheet);
		}
		else{
			try{
				var styleSheet = document.ceateStyleSheet();
			}catch(e){
				// if we went past the 31 stylesheet limit in IE, we will combine all existing stylesheets into one. 
				var styleSheets = dojox.html.getStyleSheets(); // we would only need the IE branch in this method if it was inlined for other uses
				var cssText = "";
				for(var i in styleSheets){
					var styleSheet = styleSheets[i];
					if(styleSheet.href){
						aggregate =+ "@import(" + styleSheet.href + ");";
					}else{
						aggregate =+ styleSheet.cssText;
					}
					dojo.destroy(styleSheets.owningElement);
				}
				var aggregate = dojox.html.getDynamicStyleSheet("_aggregate");
				aggregate.cssText = cssText;
				return dojox.html.getDynamicStyleSheet(styleSheetName); 
			}
			styleSheet.cssText = css;
		}
		return css;
	}
	return {
		load: function(id, parentRequire, loaded, config){
			var xhr = typeof XMLHttpRequest == "undefined" ?
				new ActiveXObject("Microsoft.XMLHTTP") :
				new XMLHttpRequest;
			var url = parentRequire.toUrl(id + ".css");
			xhr.open("GET", url, true);
			xhr.onreadystatechange = function(){
				if(xhr.readyState == 4){
					if(xhr.status < 400){
						processCss(xhr.responseText, url.replace(/[^\/]+$/,''), )
						loaded(insertCss());
					}else{
						throw new Error("Unable to load css " + url);
					}
				}
			};
			xhr.send();
		}
	};
});